import 'dart:convert';
import 'dart:io';

import 'package:recase/recase.dart';

void main(List<String> arguments) {
  var file = new File(arguments.first);

  if (!file.existsSync()) {
    print('Cannot find the file "${arguments.first}".');
  }

  var content = file.readAsStringSync();
  Map<String, dynamic> icons = json.decode(content);

  Map<String, String> iconDefinitions = {};

  for (String iconName in icons.keys) {
    iconDefinitions[iconName] = generateExampleIcon(iconName);
  }

  List<String> generatedOutput = [
    '',
    "import 'package:feather_icons_flutter/feather_icons_flutter.dart';",
    "import 'package:feather_icons_flutter/example_icon.dart';",
    '',
    '// THIS FILE IS AUTOMATICALLY GENERATED!',
    '',
    'final icons = <ExampleIcon>[',
  ];

  generatedOutput.addAll(iconDefinitions.values);

  generatedOutput.add('];');

  File output = new File('example/lib/icons.dart');
  output.writeAsStringSync(generatedOutput.join('\n'));
}

String generateExampleIcon(String iconName) {
  iconName = new ReCase(iconName).camelCase;
  return "ExampleIcon(FeatherIcons.$iconName, '$iconName'),";
}
